<template>
  <!-- Input container -->
  <div
    :class="{
      ...getElementCssClass('container'),
      ...getRootElementCSSClasses()
    }"
  >
    <!--
      @slot Label slot
    -->
    <slot name="label">
      <div
        v-if="label.length > 0"
        :class="getElementCssClass('label')"
      >
        <label :for="name">
          {{ label }}
          <span v-if="required"> *</span>
        </label>
      </div>
    </slot>

    <t-select
      ref="select"
      v-model="vModel"
      :name="name"
      :fixed-classes="tSelectStyle.fixedClasses"
      :classes="tSelectStyle.classes"
      :variants="tSelectStyle.variants"
      :variant="variant"
      :placeholder="placeholder"
      :search-box-placeholder="searchBoxPlaceholder"
      :options="localOptions"
      :value-attribute="valueAttribute"
      :text-attribute="textAttribute"
      :clearable="!required"
    />

    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Description slot
        @binding {string} className - The description class
      -->
      <slot
        v-if="description === true || description.length > 0"
        name="description"
        :class-name="getElementCssClass('description')"
      >
        <div :class="getElementCssClass('description')">
          <p>{{ description }}</p>
        </div>
      </slot>
    </transition>

    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Error slot
      -->
      <slot
        v-if="error.length > 0"
        name="error"
      >
        <div :class="getElementCssClass('error')">
          <p>{{ error }}</p>
        </div>
      </slot>
    </transition>
  </div>
</template>

<script>
// Components
import BaseInput from '../BaseInput'

import SelectStyle from './style'

/**
 * **VSelect** component
 *
 * See also [vue-tailwind TRichSelect documentation](https://www.vue-tailwind.com/docs/select)
 */
export default {
  name: 'VSelect',
  extends: BaseInput,
  refs: [
    't-select'
  ],
  props: {
    /**
     * value (to use v-model directive)
     *
     * See also how to [customize component v-model](https://vuejs.org/v2/guide/components-custom-events.html#Customizing-Component-v-model)
     */
    value: {
      type: [ String, Number, Array ],
      default () {
        return ''
      }
    },
    /**
     * placeholder
     */
    placeholder: {
      type: String,
      default: function () {
        return this.$filters.capitalize(this.$t('global.select'))
      }
    },
    /**
     * searchBoxPlaceholder
     */
    searchBoxPlaceholder: {
      type: String,
      default: function () {
        return this.$filters.capitalize(this.$t('global.search'))
      }
    },
    /**
     * options
     */
    options: {
      type: [ Array, Object ],
      default: function () {
        return undefined
      }
    },
    /**
     * Reset option (set the select v-model to "null" value)
     * If object, must follow vue-taiwlind select options format:
     * https://www.vue-tailwind.com/docs/rich-select#options-format
     */
    resetOption: {
      type: [ Boolean, Object ],
      default: false
    },
    /**
     * valueAttribute
     */
    valueAttribute: {
      type: String,
      default () {
        return undefined
      }
    },
    /**
     * textAttribute
     */
    textAttribute: {
      type: String,
      default () {
        return undefined
      }
    }
  },
  computed: {
    /**
     * ⚠ We have to return css classes as array because vue-tailwind Select component
     * does not accept classes as object
     */
    tSelectStyle () {
      return {
        fixedClasses: this.overriddenStyle.fixedClasses.select,
        classes: this.overriddenStyle.classes.select,
        variants: Object.keys(this.overriddenStyle.variants).reduce((obj, variant) => {
          obj[variant] = this.overriddenStyle.variants[variant].select
          return obj
        }, {})
      }
    },
    /**
     * Returns the processed options for select
     * If `reset-option` prop set, add as first options array item
     */
    localOptions: function () {
      const itemsToConcat = []
      if (this.resetOption) {
        let _resetOption
        // resetOption can be boolean
        if (typeof this.resetOption === 'boolean') {
          _resetOption = this.getDefaultResetOption()
        } else {
          _resetOption = this.resetOption
          // Ensure meta is set
          if (!_resetOption.meta) _resetOption.meta = {}
          if (!_resetOption.meta.resetOption) _resetOption.meta.resetOption = true
        }
        itemsToConcat.push(_resetOption)
      }
      return itemsToConcat.concat(this.options)
    }
  },
  methods: {
    /**
     * The default reset option to pass in case of we want it
     * @returns {object} - The default reset option object
     */
    getDefaultResetOption () {
      return {
        value: null,
        text: this.$filters.capitalize(this.$t('global.none_unisex')),
        meta: {
          resetOption: true // add this meta property to tag option
        }
      }
    }
  },
  // Variantable option
  style: SelectStyle
}
</script>

<style lang="scss">
  ._select-container {
    @apply @dark:text-white;

    ._select-label {
      @apply mb-2;
    }

    ._select {
      @apply relative;
    }

    ._select-description {
      @apply mb-2;
      @apply text-sm text-gray-400;
    }

    ._select-error {
      @apply text-sm text-@light-error;
      @apply mb-2;
    }
  }
</style>
